/*


*/

import java.util.concurrent.locks.Lock;
import java.util.Random;

/**
   Each time a Consumer should consume an item, it
   randomly chooses a non-empty buffer to get an
   item from.
*/
class Consumer_v2 implements Runnable
{
   private final Random rn = new Random();
   private final Lock[] lock;
   private final Buffer[] buf;
   private final char c;
   private int ms;


   /**
      Create a Consumer that uses the given arrays of locks and buffers.
      The consumer will randomly choose a buffer from the array of buffers
      each time the consumer consumes an item. The consumer locks the buffer
      and checks if the buffer is empty. If it is, the consumer will release
      the lock and then randomly choose another buffer.

      After successfully getting an item from a buffer, the consumer
      should sleep for the given number of milliseconds.

      @param lock  array of {@link Lock} objects, one for each (@link Buffer}
      @param buf   array of {@link Buffer} objects
      @param c     character to put into a buffer in place of a consumed character
      @param ms    milliseconds of delay after consuming one item
   */
   public Consumer_v2(final Lock[] lock, final Buffer[] buf, final char c, final int ms)
   {

   }


   @Override
   public void run()
   {
      try
      {
         while(! Thread.currentThread().isInterrupted())
         {

         }
      }
      catch (InterruptedException e)
      {
      }
   }
}
