/*


*/

import java.util.concurrent.TimeUnit;
import java.util.Random;
import java.util.Optional; // for the return value of the buffer's get()

/**
   Each time a Consumer should consumes an item, it
   randomly chooses a buffer to get an item from.
   If the buffer's get() method times out, the
   consumer will randomly chooses another buffer.
*/
class Consumer_v3 implements Runnable
{
   private final Random rn = new Random();
   private final Buffer_TimeOut[] buf;
   private final char c;
   private int ms;

   /**
      Create a Consumer that uses the given array of timed buffers.
      The consumer will randomly choose a buffer from the array
      each time the consumer consumes an item. If the buffer's
      get() method times out, the consumer will randomly choose
      another buffer.

      After successfully getting an item from a buffer, the consumer
      should sleep for the given number of milliseconds.

      @param buf  array of {@link Buffer} objects
      @param c    character to put into a buffer in place of a consumed character
      @param ms   milliseconds of delay after consuming one item
   */
   public Consumer_v3(final Buffer_TimeOut[] buf, final char c, final int ms)
   {

   }


   @Override
   public void run()
   {
      try
      {
         while(! Thread.currentThread().isInterrupted())
         {

         }
      }
      catch (InterruptedException e)
      {
      }
   }
}
