/*


*/

import java.util.concurrent.locks.Lock;
import java.util.Random;

/**
   Each time a Producer should produce an item, it
   randomly chooses a non-full buffer to put the
   item into.
*/
class Producer_v2 implements Runnable
{
   private final Random rn = new Random();
   private final Lock[] lock;
   private final Buffer[] buf;
   private final char c;
   private int ms;


   /**
      Create a Producer that uses the given arrays of locks and buffers.
      The producer will randomly choose a buffer from the array of buffers
      each time the producer produces an item. The producer locks the buffer
      and checks if the buffer is full. If it is, the producer will release
      the lock and then randomly choose another buffer.

      After successfully putting an item in a buffer, the producer
      should sleep for the given number of milliseconds.

      @param lock  array of {@link Lock} objects, one for each (@link Buffer}
      @param buf   array of {@link Buffer} objects
      @param c     character to place into a buffer
      @param ms    milliseconds of delay after producing one item
   */
   public Producer_v2(final Lock[] lock, final Buffer[] buf, final char c, final int ms)
   {

   }


   @Override
   public void run()
   {
      try
      {
         while(! Thread.currentThread().isInterrupted())
         {

         }
      }
      catch (InterruptedException e)
      {
      }
   }
}
