/*

*/

import java.util.concurrent.TimeUnit;
import java.util.Random;

/**
   Each time a Producer should produce an item, it
   randomly chooses a buffer to put the item into.
   If the buffer's put() method times out, the
   producer will randomly chooses another buffer.
*/
class Producer_v3 implements Runnable
{
   private final Random rn = new Random();
   private final Buffer_TimeOut[] buf;
   private final char c;
   private int ms;

   /**
      Create a Producer that uses the given array of timed buffers.
      The producer will randomly choose a buffer from the array
      each time the producer produces an item. If the buffer's
      put() method times out, the producer will randomly choose
      another buffer.

      After successfully putting an item in a buffer, the producer
      should sleep for the given number of milliseconds.

      @param buf  array of {@link Buffer} objects
      @param c    character to place into a buffer
      @param ms   milliseconds of delay after producing one item
   */
   public Producer_v3(final Buffer_TimeOut[] buf, final char c, final int ms)
   {

   }


   @Override
   public void run()
   {
      try
      {
         while(! Thread.currentThread().isInterrupted())
         {

         }
      }
      catch (InterruptedException e)
      {
      }
   }
}
