/*
   Do not modify this file.
*/

import static java.util.concurrent.TimeUnit.SECONDS;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

/**
   Use the Buffer base class for the buffers and move
   the locking out of the Buffer_Bounded class into
   the Producer and Consumer classes which can then
   check if buffers are full or empty.
*/
public class ProducersConsumers_v2
{
   public static void main(String[] args)
   {
      final int size = 16;
      Buffer[] buf = {new Buffer(size/2, '[', '0', '_', ']', size), // half full
                      new Buffer(size/2, '{', '0', '=', '}', size),
                      new Buffer(size/2, '<', '0', '-', '>', size)};

      System.out.println(buf[0]);
      System.out.println(buf[1]);
      System.out.println(buf[2]);

      Lock[] lock = new ReentrantLock[buf.length]; // one lock for each buffer
      for (int i = 0; i < buf.length; ++i)
      {
         lock[i] = new ReentrantLock();
      }

      Producer_v2 producer1 = new Producer_v2(lock, buf, '1', 30);
      Producer_v2 producer2 = new Producer_v2(lock, buf, '2', 30);
      Consumer_v2 consumer1 = new Consumer_v2(lock, buf, '@', 30);

      Thread t1 = new Thread(producer1);
      Thread t2 = new Thread(producer2);
      Thread t3 = new Thread(consumer1);

      t1.start();
      t2.start();
      t3.start();

      try
      {
         SECONDS.sleep(60);  // 60 seconds
       //SECONDS.sleep(300); // 5 minutes

         t1.interrupt();
         t2.interrupt();
         t3.interrupt();

         t1.join(); System.out.println("t1 done");
         t2.join(); System.out.println("t2 done");
         t3.join(); System.out.println("t3 done");
      }
      catch (InterruptedException e)
      {
      }
   }
}
