/*
   Do not modify this file.
*/

import static java.util.concurrent.TimeUnit.SECONDS;

/**
   Use the TimeOutBuffer class for the buffers.
   The producers and consumers can then back off
   of buffers that are full or empty.
*/
public class ProducersConsumers_v3
{
   public static void main(String[] args)
   {
      final int size = 16;
      Buffer_TimeOut[] buf = {new Buffer_TimeOut(size/2, '[', '0', '_', ']', size), // half full
                              new Buffer_TimeOut(size/2, '{', '0', '=', '}', size),
                              new Buffer_TimeOut(size/2, '<', '0', '-', '>', size)};

      System.out.println(buf[0]);
      System.out.println(buf[1]);
      System.out.println(buf[2]);

      Producer_v3 producer1 = new Producer_v3(buf, '1', 30);
      Producer_v3 producer2 = new Producer_v3(buf, '2', 30);
      Consumer_v3 consumer1 = new Consumer_v3(buf, '@', 30);

      Thread t1 = new Thread(producer1);
      Thread t2 = new Thread(producer2);
      Thread t3 = new Thread(consumer1);

      t1.start();
      t2.start();
      t3.start();

      try
      {
         SECONDS.sleep(60);  // 60 seconds
       //SECONDS.sleep(300); // 5 minutes

         t1.interrupt();
         t2.interrupt();
         t3.interrupt();

         t1.join(); System.out.println("t1 done");
         t2.join(); System.out.println("t2 done");
         t3.join(); System.out.println("t3 done");
      }
      catch (InterruptedException e)
      {
      }
   }
}
